// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AO8C500K/driver/20ao8c500k.h $
// $Rev: 53736 $
// $Date: 2023-09-21 16:09:42 -0500 (Thu, 21 Sep 2023) $

// 20AO8C500K: Device Driver: header file

#ifndef	__20AO8C500K_H__
#define	__20AO8C500K_H__

#include "gsc_common.h"
#include "gsc_pci9056.h"



// macros *********************************************************************

#define	AO8C500K_BASE_NAME					"20ao8c500k"

// IOCTL command codes
#define	AO8C500K_IOCTL_REG_READ				OS_IOCTL_RW( 0,  12, gsc_reg_t)
#define	AO8C500K_IOCTL_REG_WRITE			OS_IOCTL_W ( 1,  12, gsc_reg_t)
#define	AO8C500K_IOCTL_REG_MOD				OS_IOCTL_W ( 2,  12, gsc_reg_t)
#define	AO8C500K_IOCTL_QUERY				OS_IOCTL_RW( 3,	  4, s32)
#define	AO8C500K_IOCTL_INITIALIZE			OS_IOCTL   ( 4)
#define	AO8C500K_IOCTL_AUTOCAL				OS_IOCTL   ( 5)
#define	AO8C500K_IOCTL_AUTOCAL_STATUS		OS_IOCTL_R ( 6,	  4, s32)
#define	AO8C500K_IOCTL_AO_CONFIG			OS_IOCTL_RW( 7,	  4, s32)
#define	AO8C500K_IOCTL_AUX_CLOCK_MODE		OS_IOCTL_RW( 8,	  4, s32)
#define	AO8C500K_IOCTL_AUX_IN_POL			OS_IOCTL_RW( 9,	  4, s32)
#define	AO8C500K_IOCTL_AUX_OUT_POL			OS_IOCTL_RW(10,	  4, s32)
#define	AO8C500K_IOCTL_AUX_NOISE			OS_IOCTL_RW(11,	  4, s32)
#define	AO8C500K_IOCTL_AUX_TRIGGER_MODE		OS_IOCTL_RW(12,	  4, s32)
#define	AO8C500K_IOCTL_BUF_CLEAR			OS_IOCTL   (13)
#define	AO8C500K_IOCTL_BUF_MODE				OS_IOCTL_RW(14,	  4, s32)
#define	AO8C500K_IOCTL_BUF_OVER_DATA		OS_IOCTL_RW(15,	  4, s32)
#define	AO8C500K_IOCTL_BUF_OVER_FRAME		OS_IOCTL_RW(16,	  4, s32)
#define	AO8C500K_IOCTL_BUF_STATUS			OS_IOCTL_R (17,	  4, s32)
#define	AO8C500K_IOCTL_BUF_FILL_LEVEL		OS_IOCTL_R (18,	  4, s32)
#define	AO8C500K_IOCTL_BUF_THRESH_LEVEL		OS_IOCTL_RW(19,	  4, s32)
#define	AO8C500K_IOCTL_BUF_THRESH_STATUS	OS_IOCTL_R (20,	  4, s32)
#define	AO8C500K_IOCTL_BURST_ENABLE			OS_IOCTL_RW(21,	  4, s32)
#define	AO8C500K_IOCTL_BURST_READY			OS_IOCTL_R (22,	  4, s32)
#define	AO8C500K_IOCTL_BURST_TRIG_SRC		OS_IOCTL_RW(23,	  4, s32)
#define	AO8C500K_IOCTL_CHANNEL_SEL			OS_IOCTL_RW(24,	  4, s32)
#define	AO8C500K_IOCTL_CLOCK_ENABLE			OS_IOCTL_RW(25,	  4, s32)
#define	AO8C500K_IOCTL_CLOCK_READY			OS_IOCTL_R (26,	  4, s32)
#define	AO8C500K_IOCTL_CLOCK_SRC			OS_IOCTL_RW(27,	  4, s32)
#define	AO8C500K_IOCTL_CLOCK_SW				OS_IOCTL   (28)
#define	AO8C500K_IOCTL_DATA_FORMAT			OS_IOCTL_RW(29,	  4, s32)
#define	AO8C500K_IOCTL_DIO_DIR_OUT			OS_IOCTL_RW(30,	  4, s32)
#define	AO8C500K_IOCTL_DIO_READ				OS_IOCTL_R (31,	  4, s32)
#define	AO8C500K_IOCTL_DIO_WRITE			OS_IOCTL_RW(32,	  4, s32)
#define	AO8C500K_IOCTL_GEN_A_ENABLE			OS_IOCTL_RW(33,	  4, s32)
#define	AO8C500K_IOCTL_GEN_A_NDIV			OS_IOCTL_RW(34,	  4, s32)
#define	AO8C500K_IOCTL_GEN_B_ENABLE			OS_IOCTL_RW(35,	  4, s32)
#define	AO8C500K_IOCTL_GEN_B_NDIV			OS_IOCTL_RW(36,	  4, s32)
#define	AO8C500K_IOCTL_IO_DMA_THRESHOLD		OS_IOCTL_RW(37,	  4, s32)
#define	AO8C500K_IOCTL_IO_PIO_THRESHOLD		OS_IOCTL_RW(38,	  4, s32)
#define	AO8C500K_IOCTL_IRQ_ENABLE			OS_IOCTL_RW(39,	  4, s32)
#define	AO8C500K_IOCTL_LOAD_READY			OS_IOCTL_R (40,	  4, s32)
#define	AO8C500K_IOCTL_LOAD_REQUEST			OS_IOCTL   (41)
#define	AO8C500K_IOCTL_OUTPUT_ENABLE		OS_IOCTL_RW(42,	  4, s32)
#define	AO8C500K_IOCTL_OUTPUT_FILTER		OS_IOCTL_RW(43,	  4, s32)
#define	AO8C500K_IOCTL_OUTPUT_MODE			OS_IOCTL_RW(44,	  4, s32)
#define	AO8C500K_IOCTL_RANGE				OS_IOCTL_RW(45,	  4, s32)
#define	AO8C500K_IOCTL_REMOTE_GND_SENSE		OS_IOCTL_RW(46,	  4, s32)
#define	AO8C500K_IOCTL_TRIGGER_SW			OS_IOCTL   (47)
#define	AO8C500K_IOCTL_TX_IO_ABORT			OS_IOCTL_R (48,	  4, s32)
#define	AO8C500K_IOCTL_TX_IO_MODE			OS_IOCTL_RW(49,	  4, s32)
#define	AO8C500K_IOCTL_TX_IO_OVER_DATA		OS_IOCTL_RW(50,	  4, s32)
#define	AO8C500K_IOCTL_TX_IO_OVER_FRAME		OS_IOCTL_RW(51,	  4, s32)
#define	AO8C500K_IOCTL_TX_IO_TIMEOUT		OS_IOCTL_RW(52,	  4, s32)
#define	AO8C500K_IOCTL_WAIT_CANCEL			OS_IOCTL_RW(53,  28, gsc_wait_t)
#define	AO8C500K_IOCTL_WAIT_EVENT			OS_IOCTL_RW(54,  28, gsc_wait_t)
#define	AO8C500K_IOCTL_WAIT_STATUS			OS_IOCTL_RW(55,  28, gsc_wait_t)
#define	AO8C500K_IOCTL_XCVR_OUTPUT			OS_IOCTL_RW(56,	  4, s32)
#define	AO8C500K_IOCTL_XCVR_POL				OS_IOCTL_RW(57,	  4, s32)
#define	AO8C500K_IOCTL_XCVR_TYPE			OS_IOCTL_RW(58,	  4, s32)

//*****************************************************************************
// AO8C500K_IOCTL_REG_READ
// AO8C500K_IOCTL_REG_WRITE
// AO8C500K_IOCTL_REG_MOD
//
#define	AO8C500K_REG_ENCODE(s,o)			GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	AO8C500K_GSC_BCR					AO8C500K_REG_ENCODE(4,0x00)// Board Control Register
#define	AO8C500K_GSC_DIOPR					AO8C500K_REG_ENCODE(4,0x04)// Digital I/O Port Register
#define	AO8C500K_GSC_ASIOCR					AO8C500K_REG_ENCODE(4,0x1C)// Auxiliary Sync I/O Register
#define	AO8C500K_GSC_PSR					AO8C500K_REG_ENCODE(4,0x30)// Primary Status Register
#define	AO8C500K_GSC_ACR					AO8C500K_REG_ENCODE(4,0x34)// Assembly Configuration Register
#define	AO8C500K_GSC_AVR					AO8C500K_REG_ENCODE(4,0x38)// Autocal Values Register
#define	AO8C500K_GSC_BOOR					AO8C500K_REG_ENCODE(4,0x3C)// Buffered Output Operations Register
#define	AO8C500K_GSC_OBTR					AO8C500K_REG_ENCODE(4,0x40)// Output Buffer Threshold Register
#define	AO8C500K_GSC_OBSR					AO8C500K_REG_ENCODE(4,0x44)// Output Buffer Size Register
#define	AO8C500K_GSC_AOBR					AO8C500K_REG_ENCODE(4,0x48)// Analog Output Buffer Register
#define	AO8C500K_GSC_RAGR					AO8C500K_REG_ENCODE(4,0x4C)// Rate-A Generator Register
#define	AO8C500K_GSC_RBGR					AO8C500K_REG_ENCODE(4,0x50)// Rate-B Generator Register
#define	AO8C500K_GSC_OCR					AO8C500K_REG_ENCODE(4,0x54)// Output Configuration Register

//*****************************************************************************
// AO8C500K_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	AO8C500K_QUERY_AUTOCAL_MS,			// Max autocalibrate period in ms.
	AO8C500K_QUERY_CHANNEL_MAX,			// Maximum number of channels supported.
	AO8C500K_QUERY_CHANNEL_QTY,			// The number of A/D channels. ACR D16-D17
	AO8C500K_QUERY_COUNT,				// Number of query options.
	AO8C500K_QUERY_DEVICE_TYPE,			// Value from gsc_dev_type_t
	AO8C500K_QUERY_FGEN_MAX,			// Rate Generator maximum output rate.
	AO8C500K_QUERY_FGEN_MIN,			// Rate Generator minimum output rate.
	AO8C500K_QUERY_FIFO_SIZE,			// FIFO depth in 32-bit samples
	AO8C500K_QUERY_FREF_DEFAULT,		// The default Fref. ACR D18-D19
	AO8C500K_QUERY_FSAMP_MAX,			// Maximum sample rate.
	AO8C500K_QUERY_FSAMP_MIN,			// Minimum sample rate.
	AO8C500K_QUERY_INIT_MS,				// Max initialize period in ms.
	AO8C500K_QUERY_NDIV_MAX,			// Maximum rate generator Ndiv value.
	AO8C500K_QUERY_NDIV_MIN,			// Maximum rate generator Ndiv value.
	AO8C500K_QUERY_OUTPUT_DISCONNECT,	// Is Output Disconnect supported? ACR D22
	AO8C500K_QUERY_OUTPUT_FILTER,		// The output filter frequency. ACR D24-D25
	AO8C500K_QUERY_OUTPUT_RANGE,		// The supported voltage ranges. ACR D20-D21
	AO8C500K_QUERY_PIN_A33,				// Pin A33 function. ACR D23

	AO8C500K_QUERY_LAST					// Must be very last entry.
} ao8c500k_query_t;

#define	AO8C500K_IOCTL_QUERY_ERROR			(-1)	// A query request is unknown of invalid.

// AO8C500K_QUERY_OUTPUT_RANGE options: ACR D20-D21
#define	AO8C500K_QUERY_OUTPUT_RANGE_10		0	// +-10 and +-5
#define	AO8C500K_QUERY_OUTPUT_RANGE_5		1	// +-5 and +-2.5

// AO8C500K_QUERY_PIN_A33 options: ACR D23
#define	AO8C500K_QUERY_PIN_A33_OUT_RTN		0	// Output Return
#define	AO8C500K_QUERY_PIN_A33_RMT_GND_S	1	// Remote Ground Sense

//*****************************************************************************
// AO8C500K_IOCTL_INITIALIZE				BCR D31
//
//	Parameter:	None

//*****************************************************************************
// AO8C500K_IOCTL_AUTOCAL					BCR D28, D29
//
//	Parameter:	None

//*****************************************************************************
// AO8C500K_IOCTL_AUTOCAL_STATUS			BCR D28, D29
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AO8C500K_AUTOCAL_STATUS_ACTIVE		0
#define	AO8C500K_AUTOCAL_STATUS_FAIL		1
#define	AO8C500K_AUTOCAL_STATUS_PASS		2

//*****************************************************************************
// AO8C500K_IOCTL_AO_CONFIG					OCR D16
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_AO_CONFIG_SE				0
#define	AO8C500K_AO_CONFIG_DIFF				1

//*****************************************************************************
// AO8C500K_IOCTL_AUX_CLOCK_MODE			ASIOCR D0-D1
// AO8C500K_IOCTL_AUX_TRIGGER_MODE			ASIOCR D2-D3
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_AUX_MODE_DISABLE			0
#define	AO8C500K_AUX_MODE_INPUT				1
#define	AO8C500K_AUX_MODE_OUTPUT			2

//*****************************************************************************
// AO8C500K_IOCTL_AUX_IN_POL				ASIOCR D8
// AO8C500K_IOCTL_AUX_OUT_POL				ASIOCR D9
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_AUX_POL_L2H				0
#define	AO8C500K_AUX_POL_H2L				1

//*****************************************************************************
// AO8C500K_IOCTL_AUX_NOISE					ASIOCR D10
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_AUX_NOISE_LOW				0	// output 90-140ns, input 135ns
#define	AO8C500K_AUX_NOISE_HIGH				1	// output 0.9us, inout 1.5us

//*****************************************************************************
// AO8C500K_IOCTL_BUF_CLEAR					BOOR D11, D16, D17
//
//	Parameter:	None.

//*****************************************************************************
// AO8C500K_IOCTL_BUF_MODE					BOOR D8
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_BUF_MODE_OPEN				0
#define	AO8C500K_BUF_MODE_CIRC				1

//*****************************************************************************
// AO8C500K_IOCTL_BUF_OVER_DATA				BOOR D16
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_BUF_OVER_DATA_CLR			0
#define	AO8C500K_BUF_OVER_DATA_CHK			(-1)

//		The service returns one of the below listed values.
#define	AO8C500K_BUF_OVER_DATA_NO			0
#define	AO8C500K_BUF_OVER_DATA_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_BUF_OVER_FRAME			BOOR D17
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_BUF_OVER_FRAME_CLR			0
#define	AO8C500K_BUF_OVER_FRAME_CHK			(-1)

//		The service returns one of the below listed values.
#define	AO8C500K_BUF_OVER_FRAME_NO			0
#define	AO8C500K_BUF_OVER_FRAME_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_BUF_STATUS				BOOR D12, D13, D15, OBTR D20
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO8C500K_BUF_STATUS_EMPTY			0
#define	AO8C500K_BUF_STATUS_AE				1
#define	AO8C500K_BUF_STATUS_AF				2
#define	AO8C500K_BUF_STATUS_FULL			3

//*****************************************************************************
// AO8C500K_IOCTL_BUF_FILL_LEVEL			OBSR D0-D18
//
//	Parameter:	s32
//		Values returned are from zero to 256K.

//*****************************************************************************
// AO8C500K_IOCTL_BUF_THRESH_LEVEL			OBTR D0-D18
//
//	Parameter:	s32
//		Pass in any value from zero to 256K, or
//		-1 to read the current setting.

//*****************************************************************************
// AO8C500K_IOCTL_BUF_THRESH_STATUS			OBTR D20
//
//	Parameter:	s32
//		Values returned are as follows.
#define	AO8C500K_BUF_THRESH_STATUS_CLR		0
#define	AO8C500K_BUF_THRESH_STATUS_SET		1

//*****************************************************************************
// AO8C500K_IOCTL_BURST_ENABLE				BOOR D19
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_BURST_ENABLE_NO			0
#define	AO8C500K_BURST_ENABLE_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_BURST_READY				BOOR D18
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO8C500K_BURST_READY_NO				0
#define	AO8C500K_BURST_READY_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_BURST_TRIG_SRC			OCR D14-D15
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_BURST_TRIG_SRC_RBG			0
#define	AO8C500K_BURST_TRIG_SRC_EXT			2

//*****************************************************************************
// AO8C500K_IOCTL_CHANNEL_SEL				OCR D0-D7
//
//	Parameter:	s32
//		Pass in any valid bitwise combination, or
//		-1 to read the current setting.
//		The range for  4 channel devices is 0x00000 to 0x000F.
//		The range for  8 channel devices is 0x00000 to 0x00FF.

//*****************************************************************************
// AO8C500K_IOCTL_CLOCK_ENABLE				BOOR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_CLOCK_ENABLE_NO			0
#define	AO8C500K_CLOCK_ENABLE_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_CLOCK_READY				BOOR D6
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO8C500K_CLOCK_READY_NO				0
#define	AO8C500K_CLOCK_READY_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_CLOCK_SRC					OCR D12-D13
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_CLOCK_SRC_RAG				0
#define	AO8C500K_CLOCK_SRC_EXT				2

//*****************************************************************************
// AO8C500K_IOCTL_CLOCK_SW					BCR D20, BOOR D7
// The driver will wait upto the Tx I/O Timeout period for the bit to clear.
//
//	Parameter:	None.

//*****************************************************************************
// AO8C500K_IOCTL_DATA_FORMAT				BCR D25
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_DATA_FORMAT_2S_COMP		0	// Twos Compliment
#define	AO8C500K_DATA_FORMAT_OFF_BIN		1	// Offset Binary

//*****************************************************************************
// AO8C500K_IOCTL_DIO_DIR_OUT				DIOPR D7, D15
//
//	Parameter:	s32
//		Values returned are as follows.
#define	AO8C500K_DIO_DIR_OUT_NONE			0x0000
#define	AO8C500K_DIO_DIR_OUT_D3_D0			0x0080
#define	AO8C500K_DIO_DIR_OUT_D7_D4			0x8000
#define	AO8C500K_DIO_DIR_OUT_D7_D0			0x8080

//*****************************************************************************
// AO8C500K_IOCTL_DIO_READ					DIOPR D0-D3, D8-D11
//
//	Parameter:	s32
//		Values returned are from zero to 0xFF.

//*****************************************************************************
// AO8C500K_IOCTL_DIO_WRITE					DIOPR D0-D3, D8-D11
//
//	Parameter:	s32
//		Pass in any value from zero to 0xFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AO8C500K_IOCTL_GEN_A_ENABLE				BCR D21
// AO8C500K_IOCTL_GEN_B_ENABLE				BCR D22
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_GEN_ENABLE_NO				0
#define	AO8C500K_GEN_ENABLE_YES				1

//*****************************************************************************
// AO8C500K_IOCTL_GEN_A_NDIV				RAGR D0-D23
// AO8C500K_IOCTL_GEN_B_NDIV				RBGR D0-D23
//
//	Parameter:	s32
//		Pass in any value from 98 to 0xFFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AO8C500K_IOCTL_IRQ_ENABLE				PSR D0-D1, D8-D14
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_IRQ_INIT_DONE				0x0001
#define	AO8C500K_IRQ_AUTOCAL_DONE			0x0002
#define	AO8C500K_IRQ_DIO0_L2H				0x0100
#define	AO8C500K_IRQ_BUF_THR_H2L			0x0200
#define	AO8C500K_IRQ_BUF_THR_L2H			0x0400
#define	AO8C500K_IRQ_LOAD_READY_H2L			0x0800
#define	AO8C500K_IRQ_LOAD_READY_L2H			0x1000
#define	AO8C500K_IRQ_BURST_READY			0x2000
#define	AO8C500K_IRQ_BUF_ERROR				0x4000
#define	AO8C500K_IRQ_ALL					0x7F03

//*****************************************************************************
// AO8C500K_IOCTL_LOAD_READY				BOOR D10
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO8C500K_LOAD_READY_NO				0
#define	AO8C500K_LOAD_READY_YES				1

//*****************************************************************************
// AO8C500K_IOCTL_LOAD_REQUEST				BOOR D9, D10
//	The driver will wait the write timeout for completion.
//
//	Parameter:	None

//*****************************************************************************
// AO8C500K_IOCTL_OUTPUT_ENABLE				BCR D7
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_OUTPUT_ENABLE_NO			0
#define	AO8C500K_OUTPUT_ENABLE_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_OUTPUT_FILTER				BCR D24
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AO8C500K_OUTPUT_FILTER_NO			0
#define	AO8C500K_OUTPUT_FILTER_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_OUTPUT_MODE				BCR D18
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_OUTPUT_MODE_SEQUENTIAL		0
#define	AO8C500K_OUTPUT_MODE_SIMULTANEOUS	1

//*****************************************************************************
// AO8C500K_IOCTL_RANGE						OCR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_RANGE_2_5					0
#define	AO8C500K_RANGE_5					1
#define	AO8C500K_RANGE_10					2

//*****************************************************************************
// AO8C500K_IOCTL_REMOTE_GND_SENSE			BCR D6
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AO8C500K_REMOTE_GND_SENSE_NO		0
#define	AO8C500K_REMOTE_GND_SENSE_YES		1

//*****************************************************************************
// AO8C500K_IOCTL_TRIGGER_SW				BCR D23, BOOR D20
// The driver will wait upto the Tx I/O Timeout period for the bit clear.
//
//	Parameter:	None.

//*****************************************************************************
// AO8C500K_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AO8C500K_IO_ABORT_NO				0
#define	AO8C500K_IO_ABORT_YES				1

//*****************************************************************************
// AO8C500K_IOCTL_TX_IO_MODE
//
//	Parameter:	s32
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	AO8C500K_IO_MODE_DEFAULT			GSC_IO_MODE_PIO
// GSC_IO_MODE_PIO
// GSC_IO_MODE_BMDMA
// GSC_IO_MODE_DMDMA

//*****************************************************************************
// AO8C500K_IOCTL_TX_IO_OVER_DATA
// AO8C500K_IOCTL_TX_IO_OVER_FRAME
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
#define	AO8C500K_TX_IO_OVERFLOW_IGNORE		0
#define	AO8C500K_TX_IO_OVERFLOW_CHECK		1
#define	AO8C500K_TX_IO_OVERFLOW_DEFAULT		AO8C500K_TX_IO_OVERFLOW_CHECK

//*****************************************************************************
// AO8C500K_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AO8C500K_IO_TIMEOUT_DEFAULT			10
#define	AO8C500K_IO_TIMEOUT_NO_SLEEP		0		// Do not sleep to wait for more data.
#define	AO8C500K_IO_TIMEOUT_MIN				0
#define	AO8C500K_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define	AO8C500K_IO_TIMEOUT_INFINITE		GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AO8C500K_IOCTL_WAIT_CANCEL				fields need not be valid
// AO8C500K_IOCTL_WAIT_EVENT				all fields must be valid
// AO8C500K_IOCTL_WAIT_STATUS				fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	AO8C500K_WAIT_GSC_INIT_DONE			AO8C500K_IRQ_INIT_DONE
#define	AO8C500K_WAIT_GSC_AUTOCAL_DONE		AO8C500K_IRQ_AUTOCAL_DONE
#define	AO8C500K_WAIT_GSC_BUF_ERROR			AO8C500K_IRQ_BUF_ERROR
#define	AO8C500K_WAIT_GSC_BUF_THR_H2L		AO8C500K_IRQ_BUF_THR_H2L
#define	AO8C500K_WAIT_GSC_BUF_THR_L2H		AO8C500K_IRQ_BUF_THR_L2H
#define	AO8C500K_WAIT_GSC_BURST_READY		AO8C500K_IRQ_BURST_READY
#define	AO8C500K_WAIT_GSC_DIO0_L2H			AO8C500K_IRQ_DIO0_L2H
#define	AO8C500K_WAIT_GSC_LD_RDY_H2L		AO8C500K_IRQ_LOAD_READY_H2L
#define	AO8C500K_WAIT_GSC_LD_RDY_L2H		AO8C500K_IRQ_LOAD_READY_L2H
#define	AO8C500K_WAIT_GSC_ALL				AO8C500K_IRQ_ALL
// gsc_wait_t.alt flags
#define	AO8C500K_WAIT_ALT_ALL				0x0000
// gsc_wait_t.io
#define	AO8C500K_WAIT_IO_TX_ABORT			0x0001
#define	AO8C500K_WAIT_IO_TX_DONE			0x0002
#define	AO8C500K_WAIT_IO_TX_ERROR			0x0004
#define	AO8C500K_WAIT_IO_TX_TIMEOUT			0x0008
#define	AO8C500K_WAIT_IO_ALL				0x000F

//*****************************************************************************
// AO8C500K_IOCTL_XCVR_OUTPUT				OCR D11
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_XCVR_OUTPUT_NO				0
#define	AO8C500K_XCVR_OUTPUT_YES			1

//*****************************************************************************
// AO8C500K_IOCTL_XCVR_POL					OCR D17
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_XCVR_POL_DEFAULT			0
#define	AO8C500K_XCVR_POL_INVERT			1

//*****************************************************************************
// AO8C500K_IOCTL_XCVR_TYPE					BCR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8C500K_XCVR_TYPE_TTL				0
#define	AO8C500K_XCVR_TYPE_LVDS				1



#endif
