// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AO8C500K/include/20ao8c500k_utils.h $
// $Rev: 53736 $
// $Date: 2023-09-21 16:09:42 -0500 (Thu, 21 Sep 2023) $

// 20AO8C500K: Utilities: header file

#ifndef	__20AO8C500K_UTILS_H__
#define	__20AO8C500K_UTILS_H__

#include "20ao8c500k_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ao8c500k_close_util			(int fd, int index, int verbose);
int ao8c500k_init_util			(int verbose);
int ao8c500k_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ao8c500k_open_util			(int device, int share, int index, int verbose, int* fd);
int ao8c500k_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);
int	ao8c500k_write_util			(int fd, int index, int verbose, const void* src, size_t bytes, size_t* sent);

// IOCTL utility services

int	ao8c500k_ao_config			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_AO_CONFIG
int	ao8c500k_autocal			(int fd, int index, int verbose);								// AO8C500K_IOCTL_AUTOCAL
int	ao8c500k_autocal_status		(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_AUTOCAL_STATUS
int	ao8c500k_aux_clock_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_AUX_CLOCK_MODE
int	ao8c500k_aux_in_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_AUX_IN_POL
int	ao8c500k_aux_noise			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_AUX_NOISE
int	ao8c500k_aux_out_pol		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_AUX_OUT_POL
int	ao8c500k_aux_trigger_mode	(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_AUX_TRIGGER_MODE
int	ao8c500k_buf_clear			(int fd, int index, int verbose);								// AO8C500K_IOCTL_BUF_CLEAR
int	ao8c500k_buf_fill_level		(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_BUF_FILL_LEVEL
int	ao8c500k_buf_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_BUF_MODE
int	ao8c500k_buf_over_data		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_BUF_OVER_DATA
int	ao8c500k_buf_over_frame		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_BUF_OVER_FRAME
int	ao8c500k_buf_status			(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_BUF_STATUS
int	ao8c500k_buf_thresh_level	(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_BUF_THRESH_LEVEL
int	ao8c500k_buf_thresh_status	(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_BUF_THRESH_STATUS
int	ao8c500k_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_BURST_ENABLE
int	ao8c500k_burst_ready		(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_BURST_READY
int	ao8c500k_burst_trig_src		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_BURST_TRIG_SRC
int	ao8c500k_channel_sel		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_CHANNEL_SEL
int	ao8c500k_clock_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_CLOCK_ENABLE
int	ao8c500k_clock_ready		(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_CLOCK_READY
int	ao8c500k_clock_src			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_CLOCK_SRC
int	ao8c500k_clock_sw			(int fd, int index, int verbose);								// AO8C500K_IOCTL_CLOCK_SW
int	ao8c500k_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_DATA_FORMAT
int	ao8c500k_dio_dir_out		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_DIO_DIR_OUT
int	ao8c500k_dio_read			(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_DIO_READ
int	ao8c500k_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_DIO_WRITE
int	ao8c500k_gen_a_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_GEN_A_ENABLE
int	ao8c500k_gen_a_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_GEN_A_NDIV
int	ao8c500k_gen_b_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_GEN_B_ENABLE
int	ao8c500k_gen_b_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_GEN_B_NDIV
int	ao8c500k_initialize			(int fd, int index, int verbose);								// AO8C500K_IOCTL_INITIALIZE
int	ao8c500k_irq_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_IRQ_ENABLE
int	ao8c500k_load_ready			(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_LOAD_READY
int	ao8c500k_load_request		(int fd, int index, int verbose);								// AO8C500K_IOCTL_LOAD_REQUEST
int	ao8c500k_output_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_OUTPUT_ENABLE
int	ao8c500k_output_filter		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_OUTPUT_FILTER
int	ao8c500k_output_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_OUTPUT_MODE
int	ao8c500k_query				(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_QUERY
int	ao8c500k_range				(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_RANGE
int	ao8c500k_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AO8C500K_IOCTL_REG_MOD
int	ao8c500k_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// AO8C500K_IOCTL_REG_READ
int	ao8c500k_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AO8C500K_IOCTL_REG_WRITE
int	ao8c500k_remote_gnd_sense	(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_REMOTE_GND_SENSE
int	ao8c500k_trigger_sw			(int fd, int index, int verbose);								// AO8C500K_IOCTL_TRIGGER_SW
int	ao8c500k_tx_io_abort		(int fd, int index, int verbose, s32* get);						// AO8C500K_IOCTL_TX_IO_ABORT
int	ao8c500k_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_TX_IO_MODE
int	ao8c500k_tx_io_over_data	(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_TX_IO_OVER_DATA
int	ao8c500k_tx_io_over_frame	(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_TX_IO_OVER_FRAME
int	ao8c500k_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_TX_IO_TIMEOUT
int	ao8c500k_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// AO8C500K_IOCTL_WAIT_CANCEL
int	ao8c500k_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO8C500K_IOCTL_WAIT_EVENT
int	ao8c500k_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// AO8C500K_IOCTL_WAIT_STATUS
int	ao8c500k_xcvr_output		(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_XCVR_OUTPUT
int	ao8c500k_xcvr_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_XCVR_POL
int	ao8c500k_xcvr_type			(int fd, int index, int verbose, s32 set, s32* get);			// AO8C500K_IOCTL_XCVR_TYPE

// Auxiliary utility services

int	ao8c500k_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	ao8c500k_config_aux			(int fd, int index, int verbose);
int	ao8c500k_config_dio			(int fd, int index, int verbose);
int	ao8c500k_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* ndiv, double* rate);
int	ao8c500k_fsamp_ao_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	ao8c500k_fsamp_ao_report_all(int fd, int index, int verbose, s32* fsamp);
int	ao8c500k_id_device			(int fd, int index, int verbose);

int	ao8c500k_count_boards		(int verbose, s32* get);
int	ao8c500k_fsamp_get			(int fd, int verbose, s32* get);
int	ao8c500k_reg_list			(int fd, int detail);

const gsc_reg_def_t*	ao8c500k_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*	ao8c500k_reg_get_def_index	(int index);
const char*				ao8c500k_reg_get_desc		(u32 reg);
const char*				ao8c500k_reg_get_name		(u32 reg);



#endif
