// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AO8C500K/samples/id/perform.c $
// $Rev: 53736 $
// $Date: 2023-09-21 16:09:42 -0500 (Thu, 21 Sep 2023) $

// 20AO8C500K: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _output_modes(void)
{
	gsc_label("Output Modes");
	printf("Simultaneous, Sequential\n");
}



//*****************************************************************************
static void _output_configuration(void)
{
	gsc_label("Output Configuration");
	printf("Differential, Single Ended\n");
}



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate-A Generator, External, Software\n");
}



//*****************************************************************************
static void _trigger_sources(void)
{
	gsc_label("Triggering Sources");
	printf("Rate-B Generator, External, Software\n");
}



//*****************************************************************************
static void _clocking_modes(void)
{
	gsc_label("Clocking Modes");
	printf("Continuous, Triggered Burst\n");
}



//*****************************************************************************
static void _rate_generators(void)
{
	gsc_label("Rate Generators");
	printf("2 (A and B)\n");
}



//*****************************************************************************
static void _transceivers(void)
{
	gsc_label("Control Transceivers");
	printf("LVDS, TTL, Bidirectional, Polarity\n");
}



//*****************************************************************************
static void _dio_ports(void)
{
	gsc_label("Digital I/O Ports");
	printf("8-bits, nibble-wise bidirectional\n");
}



//*****************************************************************************
static void _auxiliary(void)
{
	gsc_label("Auxiliary Signals");
	printf("Clock, Sync\n");

	gsc_label("Auxiliary Controls");
	printf("Disable, Input, Output, Polarity, Noise Sensitivity\n");
}



//*****************************************************************************
static void _io_modes(void)
{
	gsc_label("I/O Modes");
	printf("PIO, BMDMA, DMDMA\n");
}



//*****************************************************************************
static int _id_device_reg(const args_t* args)
{
	int						errs;
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	printf("\n");
	ptr	= ao8c500k_reg_get_def_id(AO8C500K_GSC_ACR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, ao8c500k_reg_read);
	}
	else
	{
		errs	= 1;
		printf(	"FAIL <---  (%d. ao8c500k_reg_get_def_id, AO8C500K_GSC_ACR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= ao8c500k_reg_list(args->fd, args->detail);
 	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_output_modes();
	_output_configuration();
	_clocking_sources();
	_trigger_sources();
	_clocking_modes();
	_rate_generators();
	_transceivers();
	_dio_ports();
	_auxiliary();
	_io_modes();

	for (i = 0; i < AO8C500K_QUERY_LAST; i++)
		errs	+= ao8c500k_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_reg(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


