// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AO8C500K/utils/config_aux.c $
// $Rev: 53736 $
// $Date: 2023-09-21 16:09:42 -0500 (Thu, 21 Sep 2023) $

// 20AO8C500K: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao8c500k_config_aux
*
*	Purpose:
*
*		Configure the given device's auxiliary signals.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*
*		verbose	Work verbosely?
*
*		verbose	0: errors only, !0: all output
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int	ao8c500k_config_aux(int fd, int index, int verbose)
{
	int	errs	= 0;

	if (verbose)
	{
		gsc_label_index("Auxiliary Configuration", index);
		printf("\n");
		gsc_label_level_inc();
	}

	// Settings must be applied after the initialization call!

	errs	+= ao8c500k_aux_noise		(fd, index, verbose, AO8C500K_AUX_NOISE_HIGH,	NULL);
	errs	+= ao8c500k_aux_in_pol		(fd, index, verbose, AO8C500K_AUX_POL_L2H,		NULL);
	errs	+= ao8c500k_aux_clock_mode	(fd, index, verbose, AO8C500K_AUX_MODE_OUTPUT,	NULL);
	errs	+= ao8c500k_aux_out_pol		(fd, index, verbose, AO8C500K_AUX_POL_L2H,		NULL);
	errs	+= ao8c500k_aux_trigger_mode(fd, index, verbose, AO8C500K_AUX_MODE_OUTPUT,	NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}



